/* make plot
 */

void help(void)
{
  if (getmaxx()<639 || getmaxy()<479) selectfont(0); else selectfont(2);
  dathelp=xfont.height+1;
  athelp=5;

  setwritemode(0);
  clearviewport();
  settextjustify(0,2);

  erasebuttons();
  makebutton(getmaxx()-xfont.width*9-3,5,F1,"exit help","return back to main menu\nhotkey=[F1] or [ESC]..");

 LMENU:
  H("=== GUI MENU ===","                     [plot V"VERSION" (c) J. Kolafa]");
  H("F10;\22","GUI menu on/off (darker and shifted if menu off)");
  H("right click                         ;button","show context help on the         clicked");
  H("","- each GUI button is equivalent to a hot hey");
  H("","- some hot keys are not available as buttons");

  athelp+=xfont.height/2;
  H("=== QUIT ===","");
  H("ESC q","type twice to quit plot");
  H("Ctrl-Q Q;quit","   quit plot immediately");
  athelp+=2;
  H("K;kill all","kill all plots spawned by PARENT (given by option -p)");
  athelp+=2;
  H("K;KILL ALL","kill all plots by \'killall plot\' (if enabled by K in GUI)");
  H("","- no info nor \"plot.env\" written when killed");

  athelp+=xfont.height/2;
  H("=== MOUSE ===","");
  H("left click","digitize: print x y, on 2nd click also dx dy");
  H("mid click","print x,y in pt, useful in \"plot.eps\",\"ps.def\"");
  H("","left+mid: if TOCLIP then copy to the clipboard");
  H("right click","show file and parameter info");
  H("left drag","rectangle to zoom in");
  H("mid drag","move the graph (panning)");
  H("right drag","rescale graph");
  H("wheel","rescale graph in the y-axis");
  NEXTPAGE(LMENU,LMENU)

 LSCALE:
  H("=== SCALING ===","");
  H("+ -","zoom in/out both axes");
  H("x X","zoom in/out x-axis");
  H("y Y","zoom in/out y-axis");
  H("Ctrl-X;cx","center around x=0");
  athelp+=2;
  H("Ctrl-Y;cy","center around y=0");
  H("cursors","move viewpoint (also middle mouse panning)");
  H("R","round the axes up to int-multiples of powers of 10");
  H("Ctrl-R","round the axes to int-multiples of powers of 10");
  H("Ctrl-Z;undo","undo last zoom (also [u])");
  H("k;init","initial zoom (also [U])");
  H("Ctrl-U;recalc","  recalculate scaling (also hotkey=[F9])");
  athelp+=xfont.height/2;
  H("=== FILES ===","");
  H("r","reread files and redraw");
  H("Ins","show file and parameter info (also right click or [W])");
  H("Del","do not show  file and parameter info (also [w])");
  H("PgUp PgDn","cycle through files if FILE contains int format; e.g., x%03d.dat");
  H("{ }","as above");
  athelp+=xfont.height/2;
  H("=== REDRAW ===","");
  H("Ctrl-L","redraw");                                             
  NEXTPAGE(LMENU,LSCALE)

 LSTYLE:
  H("=== PLOT STYLE ===","");
  H("The following functions apply only if the draw style","");
  H("is not set from the command line nor by `s' in STYLE:","");
  athelp+=2;
  H("SPACE;style","toggle 3 styles: lines, points, lines+points");
  H(": ;","draw by dotted line");
  H("\\    ;\\","draw by solid line");
  H("l L","cycle through line styles (dotted/normal/thick/thicker..)");
  H(".;.","draw points as pixels (smallest dots)");
  H("p P","change point sizes");
  H("^ F12;errbar","  toggle showing error bars (if any, default=on)");

  athelp+=xfont.height/2;
  H("=== MORE ===","");
  H("[ ]","change the column to plot (y-axis), zoom (scaling) unchanged");
  H("",   "good for commands as \'plot FILE:1:3\' or \'plot FILE:A:C\'");
  H("",   "More precisely: ASCII code of the 1st char in the Y-field");
  H("",   "is changed; weird example: plot -:A:a+B \32 plot -:A:b+B");
  H("1 2 .. 9","select the column to plot (y-axis; column<10)");
  H("010 .. 099","select the column to plot (y-axis; 10<=column<100)");
  H("z Z;grid","cycle through grid styles (none, dense, thin)");
  H("F5 Ctrl-O;font","    toggle font size (small/large; not for this help)");
  NEXTPAGE(LSCALE,LSTYLE)

  LDUMP:
   H("=== OUTPUT ===","");
   H("#;EPS","export \"plot.eps\" or \"plot.ps\" with settings from \"ps.def\"");
   H("","for more info, see \".../macsimus/examples/ps.def\"");

   athelp+=xfont.height/2;
   H("P Ctrl-P;PrtScr","    dump screen in various formats"); athelp+=2;
   H("second key:",""); athelp+=2;
   H(" P;PPM on black",    "        dump screen in the PPM (Portable PixMap, P6) format"); athelp+=4;
   H(" p;PPM on white",    "        = as above, white background, some colors changed"); athelp+=4;
   H(" E;EPS on black",    "        dump screen in the EPS format"); athelp+=4;
   H(" e;EPS on white",    "        = as above, white background, some colors changed"); athelp+=4;
   H(" C;PS on black",     "        dump screen in the PS format, on A4"); athelp+=4;
   H(" c;PS on white",     "        = as above, white background, some colors changed"); athelp+=4;
   H(" O;gray PS on black","        dump screen in gray in the PS format, on A4"); athelp+=4;
   H(" o;gray PS on white","        = as above, white background, some colors changed"); 
  NEXTPAGE(LSTYLE,LDUMP)

    LPARMS:
#if PARM
  H("=== PARAMETERS ===","");
  H("There are 10 parameters denoted a-j, available in","");
  H("formulas and accessible as shell variables.","");
  H("Info on parameter not present in formulas is in gray.","");
  H("See also environment variables PLOTCMD and FIT.","");
  H("Example:","a=2 plot \"[0:99]\" \"[999]:x:sin(x+a)\"");
  H("   ;a","button to get slider for parameter a");
  H("The following functions also recenter the slider:","");
  H("a;<","decrease the value of parameter a by step");
  H("A  ;>","increase the value of parameter a by step");
  H("*;*","double the step for changing the active parameter");
  H("/  ;/","halve the step for changing the active parameter");
  H("Ctrl-A ;=0","set parameter a/the active parameter to 0");
  H("< o >","as [a] [Ctrl-A] [A] for the active parameter");
  H("F8;all0","erase all parameters");
  athelp+=xfont.height/2;
  H("v","print x,y ranges and active variables");
  H("V","export active variables to plotenv.sh");
  H("","(can be read to sh or bash by \". plotenv.sh\")");
  athelp+=xfont.height/2;
  H("=","switch to terminal to enter data from keyboard (with help)");
#else
  H("not available in this version","");
#endif /*# PARM */
  NEXTPAGE(LSCALE,LPARMS)

    LFIT:
  H("=== FITTING ===","");
#if PARM
  H("Example:","plot FILE \":a+b*A\"");
  H("For more help, run plot without arguments and select t as fi(t)","");
  H("See also environment variable FIT","");
  athelp+=2;
  H("t;std","fit the data to the function, long double (recommended)");
  athelp+=2;
  H("T;high","fit the data to the function, emulated high precision");
  H("Ctrl-T;fast","fit the data to the function, double");
  H("n N","decrease/increase the number of sampling points");
  H("","to calculate standard uncertainties of parameters");
  H(" ;0","no uncertainties calculated");
  H("   ;100","button to set the number of sampling points");
  athelp+=2;
  H("=","switch to terminal to enter data from keyboard (with help)");
#else
  H("not available in this version","");
#endif
  NEXTPAGE(LPARMS,LFIT)

 LMACRO:
#include "macrohelp.c"
  H("--- example ---","");
  H("`AaB`","define `a as: decrease parm a, increase b");
  H("`60`a",  "execute `a 60x");
  NEXTPAGE(LFIT,LMACRO)

  goto LMACRO;
}
